diff --git glib/poppler-action.cc glib/poppler-action.cc
index 72969a5..7d16d2a 100644
--- glib/poppler-action.cc
+++ glib/poppler-action.cc
@@ -25,7 +25,7 @@
  * @title: PopplerAction
  */
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerDest, poppler_dest, poppler_dest_copy, poppler_dest_free)
+G_DEFINE_BOXED_TYPE (PopplerDest, poppler_dest, poppler_dest_copy, poppler_dest_free)
 
 /**
  * poppler_dest_copy:
@@ -93,7 +93,7 @@ poppler_action_layer_copy (PopplerActionLayer *action_layer)
 	return retval;
 }
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerAction, poppler_action, poppler_action_copy, poppler_action_free)
+G_DEFINE_BOXED_TYPE (PopplerAction, poppler_action, poppler_action_copy, poppler_action_free)
 
 /**
  * poppler_action_free:
diff --git glib/poppler-annot.cc glib/poppler-annot.cc
index 312aa31..696ebcc 100644
--- glib/poppler-annot.cc
+++ glib/poppler-annot.cc
@@ -1787,7 +1787,7 @@ poppler_annot_file_attachment_get_name (PopplerAnnotFileAttachment *poppler_anno
 }
 
 /* PopplerAnnotCalloutLine */
-POPPLER_DEFINE_BOXED_TYPE (PopplerAnnotCalloutLine, poppler_annot_callout_line,
+G_DEFINE_BOXED_TYPE (PopplerAnnotCalloutLine, poppler_annot_callout_line,
 			   poppler_annot_callout_line_copy,
 			   poppler_annot_callout_line_free)
 
diff --git glib/poppler-document.cc glib/poppler-document.cc
index 41b6a04..29cd577 100644
--- glib/poppler-document.cc
+++ glib/poppler-document.cc
@@ -1740,7 +1740,7 @@ struct _PopplerIndexIter
 };
 
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerIndexIter, poppler_index_iter,
+G_DEFINE_BOXED_TYPE (PopplerIndexIter, poppler_index_iter,
 			   poppler_index_iter_copy,
 			   poppler_index_iter_free)
 
@@ -1977,7 +1977,7 @@ struct _PopplerFontsIter
 	int index;
 };
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerFontsIter, poppler_fonts_iter,
+G_DEFINE_BOXED_TYPE (PopplerFontsIter, poppler_fonts_iter,
 			   poppler_fonts_iter_copy,
 			   poppler_fonts_iter_free)
 
@@ -2552,7 +2552,7 @@ struct _PopplerLayersIter {
   int index;
 };
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerLayersIter, poppler_layers_iter,
+G_DEFINE_BOXED_TYPE (PopplerLayersIter, poppler_layers_iter,
 			   poppler_layers_iter_copy,
 			   poppler_layers_iter_free)
 
diff --git glib/poppler-enums.c.template glib/poppler-enums.c.template
index 26a51b4..eefc769 100644
--- glib/poppler-enums.c.template
+++ glib/poppler-enums.c.template
@@ -15,9 +15,9 @@
 GType
 @enum_name@_get_type (void)
 {
-  static volatile gsize g_define_type_id__volatile = 0;
+  static volatile gsize g_define_type_id = 0;
  
-  if (g_once_init_enter (&g_define_type_id__volatile)) {
+  if (g_once_init_enter (&g_define_type_id)) {
     static const G@Type@Value values[] = {
 /*** END value-header ***/
 
@@ -28,13 +28,13 @@ GType
 /*** BEGIN value-tail ***/
       { 0, NULL, NULL }
     };
-    GType g_define_type_id = 
+    GType type =
        g_@type@_register_static (g_intern_static_string ("@EnumName@"), values);
       
-    g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
+    g_once_init_leave (&g_define_type_id, type);
   }
     
-  return g_define_type_id__volatile;
+  return g_define_type_id;
 }
 
 /*** END value-tail ***/
diff --git glib/poppler-page.cc glib/poppler-page.cc
index a44edac..a81fffa 100644
--- glib/poppler-page.cc
+++ glib/poppler-page.cc
@@ -1519,7 +1519,7 @@ poppler_page_remove_annot (PopplerPage  *page,
 
 /* PopplerRectangle type */
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerRectangle, poppler_rectangle,
+G_DEFINE_BOXED_TYPE (PopplerRectangle, poppler_rectangle,
 			   poppler_rectangle_copy,
 			   poppler_rectangle_free)
 
@@ -1566,7 +1566,7 @@ poppler_rectangle_free (PopplerRectangle *rectangle)
 
 /* PopplerPoint type */
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerPoint, poppler_point,
+G_DEFINE_BOXED_TYPE (PopplerPoint, poppler_point,
                            poppler_point_copy,
                            poppler_point_free)
 
@@ -1620,7 +1620,7 @@ poppler_point_free (PopplerPoint *point)
 
 /* PopplerQuadrilateral type */
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerQuadrilateral, poppler_quadrilateral,
+G_DEFINE_BOXED_TYPE (PopplerQuadrilateral, poppler_quadrilateral,
                            poppler_quadrilateral_copy,
                            poppler_quadrilateral_free)
 
@@ -1673,7 +1673,7 @@ poppler_quadrilateral_free (PopplerQuadrilateral *quad)
 
 /* PopplerTextAttributes type */
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerTextAttributes, poppler_text_attributes,
+G_DEFINE_BOXED_TYPE (PopplerTextAttributes, poppler_text_attributes,
 			   poppler_text_attributes_copy,
 			   poppler_text_attributes_free)
 
@@ -1779,7 +1779,7 @@ poppler_text_attributes_free (PopplerTextAttributes *text_attrs)
  */
 
 /* PopplerColor type */
-POPPLER_DEFINE_BOXED_TYPE (PopplerColor, poppler_color, poppler_color_copy, poppler_color_free)
+G_DEFINE_BOXED_TYPE (PopplerColor, poppler_color, poppler_color_copy, poppler_color_free)
 
 /**
  * poppler_color_new:
@@ -1826,7 +1826,7 @@ poppler_color_free (PopplerColor *color)
 }
 
 /* PopplerLinkMapping type */
-POPPLER_DEFINE_BOXED_TYPE (PopplerLinkMapping, poppler_link_mapping,
+G_DEFINE_BOXED_TYPE (PopplerLinkMapping, poppler_link_mapping,
 			   poppler_link_mapping_copy,
 			   poppler_link_mapping_free)
 
@@ -1883,7 +1883,7 @@ poppler_link_mapping_free (PopplerLinkMapping *mapping)
 }
 
 /* Poppler Image mapping type */
-POPPLER_DEFINE_BOXED_TYPE (PopplerImageMapping, poppler_image_mapping,
+G_DEFINE_BOXED_TYPE (PopplerImageMapping, poppler_image_mapping,
 			   poppler_image_mapping_copy,
 			   poppler_image_mapping_free)
 
@@ -1927,7 +1927,7 @@ poppler_image_mapping_free (PopplerImageMapping *mapping)
 }
 
 /* Page Transition */
-POPPLER_DEFINE_BOXED_TYPE (PopplerPageTransition, poppler_page_transition,
+G_DEFINE_BOXED_TYPE (PopplerPageTransition, poppler_page_transition,
 			   poppler_page_transition_copy,
 			   poppler_page_transition_free)
 
@@ -1976,7 +1976,7 @@ poppler_page_transition_free (PopplerPageTransition *transition)
 }
 
 /* Form Field Mapping Type */
-POPPLER_DEFINE_BOXED_TYPE (PopplerFormFieldMapping, poppler_form_field_mapping,
+G_DEFINE_BOXED_TYPE (PopplerFormFieldMapping, poppler_form_field_mapping,
 			   poppler_form_field_mapping_copy,
 			   poppler_form_field_mapping_free)
 
@@ -2033,7 +2033,7 @@ poppler_form_field_mapping_free (PopplerFormFieldMapping *mapping)
 }
 
 /* PopplerAnnot Mapping Type */
-POPPLER_DEFINE_BOXED_TYPE (PopplerAnnotMapping, poppler_annot_mapping,
+G_DEFINE_BOXED_TYPE (PopplerAnnotMapping, poppler_annot_mapping,
 			   poppler_annot_mapping_copy,
 			   poppler_annot_mapping_free)
 
diff --git glib/poppler-private.h glib/poppler-private.h
index 9abdd7c..6305b7c 100644
--- glib/poppler-private.h
+++ glib/poppler-private.h
@@ -139,23 +139,4 @@ char *_poppler_goo_string_to_utf8(GooString *s);
 gboolean _poppler_convert_pdf_date_to_gtime (GooString *date,
 					     time_t    *gdate);
 
-/*
- * A convenience macro for boxed type implementations, which defines a
- * type_name_get_type() function registering the boxed type.
- */
-#define POPPLER_DEFINE_BOXED_TYPE(TypeName, type_name, copy_func, free_func)          \
-GType                                                                                 \
-type_name##_get_type (void)                                                           \
-{                                                                                     \
-        static volatile gsize g_define_type_id__volatile = 0;                         \
-	if (g_once_init_enter (&g_define_type_id__volatile)) {                        \
-	        GType g_define_type_id =                                              \
-		    g_boxed_type_register_static (g_intern_static_string (#TypeName), \
-		                                  (GBoxedCopyFunc) copy_func,         \
-						  (GBoxedFreeFunc) free_func);        \
-		g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);    \
-	}                                                                             \
-	return g_define_type_id__volatile;                                            \
-}
-
 #endif
diff --git glib/poppler-structure-element.cc glib/poppler-structure-element.cc
index e26f4c4..d624345 100644
--- glib/poppler-structure-element.cc
+++ glib/poppler-structure-element.cc
@@ -701,7 +701,7 @@ struct _PopplerStructureElementIter
   unsigned index;
 };
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerStructureElementIter,
+G_DEFINE_BOXED_TYPE (PopplerStructureElementIter,
                            poppler_structure_element_iter,
                            poppler_structure_element_iter_copy,
                            poppler_structure_element_iter_free)
@@ -902,7 +902,7 @@ struct _PopplerTextSpan {
   PopplerColor color;
 };
 
-POPPLER_DEFINE_BOXED_TYPE (PopplerTextSpan,
+G_DEFINE_BOXED_TYPE (PopplerTextSpan,
                            poppler_text_span,
                            poppler_text_span_copy,
                            poppler_text_span_free)
